package archer.reference.tip;

import java.util.ArrayList;
import java.util.Random;

import android.app.Activity;
import android.text.InputFilter;
import android.text.InputType;
import android.view.View.OnClickListener;
import android.view.View.OnFocusChangeListener;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.TableRow;
import android.widget.TextView;


public class Diner
{
	public double preTaxTotal = 0.0;
	public double grandTotal = 0.0;
	public EditText editName;
	public ArrayList<EditText> editDollarList = new ArrayList<EditText>();
	public ImageButton button;
	public TextView textName;
	public TextView textDollar;
	public InputFilter[] filter8 = new InputFilter[1];
	public InputFilter[] filter16 = new InputFilter[1];
	private String[] randomNames =
			{
			//Leaders
			"Muhammad", "Alexander","Gandhi","Bonaparte","Lincoln","Caesar","Washington","Khan","Churchill","Christ",
			"King","Mandela","Constantine", "Charlemagne","Elizabeth","Atilla","Roosevelt","Gautama","Cleopatra",
			"Reagan","de Gaulle","Ramses","Xerxes","Pericles","Mao","Isabella","Lenin","Franklin","Justinian",
			"Catherine","Victoria","Kennedy","Asoka","Jefferson","Hannibal","Wilson","Grant","Lee","Darius",
			"von Bismarck","Alfred","Augustus","Eisenhower","Cromwell","Saladin","Madison","Adams","Hamilton","Jay",
			//Women
			"Joan","Anne","Anthony","Nightingale","Tubman","Barton","Frank","Magdalene","Curie","Antoinette",
			"Teresa","Alcott","Oakley","Keller","Earhart","Parks",
			//Fictional
			"Sterling","Lana","Malory","Krieger","Cyril",
			"Snoopy","Spongebob","Batman","Xena","Thor",
			"Samus","Mewtwo",
			"Arthas","Jaina","Illidan","Malfurion","Ragnaros",
			//Writers
			"Shakespeare","Alighieri","Homer","Tolstoy","Chaucer","Dickens","Milton","Virgil","Shikibu","Sophocles",
			"Faulkner","Dostoevsky","Eliot","Proust","Austen","Yeats","Euripides","Melville","Keats","Du Fu",
			"Li Bai","Kafka","Moliere","Aristophanes","Wordsworth","Ibsen","Whitman","Swift","Hemingway","Shaw",
			"Lawrence","Baudelaire","Beckett","Pope","Poe","Conrad","Twain","Xueqin","Voltaire","Shelley",
			"Hawthorne","Fitzgerald","Hugo","Stein","Wilde","Lu Xun","Sun Tzu",
			//Artists
			"Picasso","Michelangelo","Titian","Da Vinci","Monet","Rembrandt","Van Gogh","DuChamp","Cezanne","Magritte",
			"Donatello","Raphael","Botticelli","Caravaggio","Bernini","Manet","Degas","Renoir","Rousseau","Cassatt",
			"Matisse","Rivera","Chagall","O\'Keefe","Warhol","Bach","Mozard","Beethoven","Wagner","Schubert",
			"Schumann","Chopin","Liszt","Brahms","Verdi","Mahler","Tchaikovsky","Rachmaninov","Handel","Haydn",
			"Debussy","Stravinsky","Bartok",
			//Philosophers
			"Aristotle","Pascal","Epicurus","von Hayek","Nietzsche","Keynes","Galilei","Leibniz","Hippocrates","Kant",
			"Sartre","Dewey","Locke","Marx","Demosthenes","Confucius","Mencius","Lao Zi","Plato","Socrates","Plutarch",
			"Pythagoras","Descartes","Kierkegaard","Carlyle","Hobbes","Rand","Bacon","Berkeley","Diderot","Butler",
			//Scientists
			"Archimedes","Newton","Einstein","Bohr","Darwin","Pasteur","Freud","Lavoisier","Kepler","Copernicus",
			"Faraday","Maxwell","Bernard","Boas","Heisenberg","Schrodinger","Rutherford","Brahe","Planck","Lyell",
			"Hubble","Crick","Fermi","Euler","Huygens","Gauss","Koch","Mendeleev","Tesla","Euclid",
			"Mendel","Dalton","Oppenheimer","Turing","Salk","Fleming","Boyle","Fahrenheit","Hooke","Sagan",
			//last thoughts
			"Luther","Columbus","Solomon"
			};
	
	
	public Diner(EditText editNameInit, EditText editDollarListInit, ImageButton buttonInit, TextView textNameInit, TextView textDollarInit, Activity background)
	{
		
		//input filers
        filter8[0] = new InputFilter.LengthFilter(8);
        filter16[0] = new InputFilter.LengthFilter(16);
        
        
		//init stuff
		editName = editNameInit;
		editDollarList.add(editDollarListInit);
		button = buttonInit;
		textName = textNameInit;
		textDollar = textDollarInit;
		
		
		//set random name
		Random rand = new Random();
		editName.setText(randomNames[rand.nextInt(randomNames.length)]);
		setName();
		
		//set amounts
		editDollarList.get(0).setText("$0.00");
		textDollar.setText("$0.00");
		
		//set button image
        button.setImageResource(R.drawable.additem);
        
        //set input types
        editName.setInputType(InputType.TYPE_CLASS_TEXT | InputType.TYPE_TEXT_VARIATION_PERSON_NAME);
        editDollarListInit.setInputType(InputType.TYPE_CLASS_NUMBER | InputType.TYPE_NUMBER_FLAG_DECIMAL);
        
		//set button listener
		button.setOnClickListener((OnClickListener) background);
		editName.setOnFocusChangeListener((OnFocusChangeListener) background);
		editDollarListInit.setOnFocusChangeListener((OnFocusChangeListener) background);
		
		//set select all thing
		editName.setSelectAllOnFocus(true);
		editDollarListInit.setSelectAllOnFocus(true);
		
		//request focus
		editDollarListInit.requestFocus();
		
		//set filters
		editName.setFilters(filter16);
		editDollarListInit.setFilters(filter8);
		
		
	}
	
	//set name, set text on all name related fields
	public void setName()
	{
		textName.setText(editName.getText()+":");
	}
	
	//add new item for a diner
	public void newItem(EditText editDollarNew, Activity background)
	{
		editDollarList.add(editDollarNew);
		//the get size - 1 thing is to get the last added item in list, which i just added
		editDollarNew.setLayoutParams(new TableRow.LayoutParams(1));
		editDollarNew.setText("$0.00");
		editDollarNew.setInputType(InputType.TYPE_CLASS_NUMBER | InputType.TYPE_NUMBER_FLAG_DECIMAL);
		editDollarNew.setFilters(filter8);
		editDollarNew.setOnFocusChangeListener((OnFocusChangeListener) background);
		editDollarNew.setSelectAllOnFocus(true);
		editDollarNew.requestFocus();
	}
	
	//react to change in an item
	public void updateItem ()
	{
		
	}
	
	//calc pretax total
	public void updateSubTotal()
	{
		preTaxTotal = 0.0;
		for (EditText item : editDollarList)
		{
			double addTo = Double.parseDouble(item.getText().toString().replace("$", "").replace(",", ""));
			item.setFilters(filter16);
			item.setText("$"+String.format("%,.02f", addTo));
			item.setFilters(filter8);
			preTaxTotal += addTo;
		}
	}
	
	//calc final total
	public void updateFinalTotal(double subTotal, double taxTotal, double tipTotal)
	{
		double ratio = preTaxTotal/subTotal;
		textDollar.setText("$"+String.format("%,.02f", preTaxTotal+ratio*taxTotal+ratio*tipTotal));
		if (textDollar.getText().toString().contains("N"))
		{
			textDollar.setText("$0.00");
		}
	}
}
